#include <bits/stdc++.h>
using namespace std;

using ll = long long;
const ll INF = 1e18;

void solve() {
    // freopen("1.in", "r", stdin);
    // freopen("1.out", "w", stdout);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector<int> b(n);
    for (int i = 0; i < n; i++)
        cin >> b[i];
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll sum = INF;
        for (int j = 0; j <= i; j++) {
            sum = min<ll>(sum, abs(a[j] - b[n - i - 1 + j]));
        }
        for (int j = i + 1; j < n; j++) {
            sum = min<ll>(sum, abs(a[j] - b[j - (i + 1)]));
        }
        ans = max(ans, sum);
    }
    cout << ans << "\n";
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}