#include <bits/stdc++.h>
using namespace std;

#define p_b push_back 
#define fi first 
#define se second 

using pii = pair<int, int>;
using ll = long long;
const ll INF = 1e18;


bool intersect(pair<pii, int>a, pair<pii, int>b)
{
    auto [s, r1] = a;
    auto [x1, y1] = s;
    auto [s1, r2] = b;
    auto [x2, y2] = s1;
    return (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) == (r1+r2)*(r1+r2);
}

void dfs(int u,vector<vector<int>> &g, vector<int>&clr, int &cnt1, int &cnt2)
{
    if(cnt1!=-1)
    {
    if(clr[u]==1)
    cnt1++;
    else
    cnt2++;
    }
    else
    clr[u]=-1;
    for(int i:g[u])
    {
        if(clr[i]==clr[u])
        {
            cnt1=-1;
            cnt2=-1;
        }
        else
        if(!clr[i])
        {
            clr[i] = 1+clr[u]%2;
            dfs(i, g, clr, cnt1, cnt2);
        }
    }
    if(cnt1==-1)
    clr[u]=-1;
}

void solve() {
    // freopen("1.in", "r", stdin);
    // freopen("1.out", "w", stdout);

   int n;
   cin>>n;
   vector<set<int>>g(n);
   for(int i=0;i<n-1;i++)
   {
    int x, y;
    cin>>x>>y;
    x--;
    y--;
    g[x].insert(y);
    g[y].insert(x);

   }
   set<pii>st;
   vector<int>sz(n, 1);
   for(int i=0;i<n;i++)
   {
    if(g[i].size()==1)
    st.insert({1, i});
   }
   while(n>1)
   {
        auto [s, x] = (*st.begin());
        st.erase(st.begin());
        auto y = (*g[x].begin());
        if(sz[y]<sz[x])
        {
            cout<<"NO";
            return;
        }
        g[x].erase(g[x].begin());
        sz[y]+=sz[x];
        g[y].erase(x);
        if(g[y].size()==1)
        {
            st.insert({sz[y], y});
        }
        n--;
   }
   cout<<"Yes";

}

int32_t main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}