#include <bits/stdc++.h>
using namespace std;

using ll = long long;
const ll INF = 1e18;
template<typename T> 
using graph = vector<multiset<T>>;
int n;
const int N = 3000;
int used[N];
int cnt[N];
graph<int> g(N);
int cur = 0;
string s;
string t;
vector<pair<string, int>> ans;
vector<int>res;
void dfs(int v) {
    auto x = g[v];
    for (int to: x) {
        if(g[v].find(to)!=g[v].end())
        {
            g[v].erase(g[v].find(to));
            dfs(to);
        }

    }
    res.push_back(v);
}

void solve(string s, string t) {
    n = s.size();
    // cin >> n;
    // cin >> s >> t;
    string init = t;
    map<char, int> mp;
    for (int i = 0; i < n; i++) {
        if (s[i] == t[i])   continue;
        mp[s[i]]++;
        mp[t[i]]--;
    }
    for (int i = 0; i < n; i++) {
        if (s[i] == t[i])   continue;
        if (mp[t[i]] < 0) {
            mp[t[i]]++;
            t[i] = '-';
        }
        if (s[i] == '-')
            g[0].insert(i + 3);
        if (s[i] == 'C')
            g[1].insert(i + 3);
        if (s[i] == 'M')
            g[2].insert(i + 3);
    
        if (t[i] == '-')
            g[i + 3].insert(0);
        if (t[i] == 'C')
            g[i + 3].insert(1);
        if (t[i] == 'M')
            g[i + 3].insert(2);
    }
    cnt[0] = g[0].size();
    cnt[1] = g[1].size();
    cnt[2] = g[2].size();
    dfs(0);
    reverse(res.begin(), res.end());
    int cur = 0;
    string R = init; 
    char last = '-';
    for (auto i : res) {
        if (i <= 2)
            continue;
        ans.push_back({"DRIVE", i - 2});

        if (cur) {
            R[i - 3] = last;
            ans.push_back({"DROPOFF", -1});
            cur--;
        }
        if (t[i - 3] != '-') {
            ans.push_back({"PICKUP", -1});
            last = init[i - 3];
            init[i - 3] = '-';
            cur++;
        }
    }

    // cout<<"------------------"<<endl;
    // for(int i:res)cout<<i<<" ";

    for (int i = 0; i< n; i++) {
        if (s[i] != '-' && (s[i] != R[i])) {
            cout << "BAD\n";
            cout << R << "\n";
            exit(1);
        }
    }
    return;
    cout << ans.size() << "\n";
    for (auto [s, t]: ans) {
        cout << s;
        if (t != -1)
            cout << " " << t;
        cout << "\n";
    }
}

bool stupid(string s, string t) {
    vector<int> order;
    int n = s.size();
    for (int i = 0; i < n; i++) {
        order.push_back(i);
    }

    do {
        bool good = 1;
        char cur = '-';
        for (auto i : order) {
            if (s[i] == t[i])   continue;
            if (s[i] != cur) {
                good = 0;
                break;
            }
            cur = t[i];
        }
        if (good)
            return 1;
    } while(next_permutation(order.begin(), order.end()));
    return false;
}

pair<string, string> test(int n) {
    string s(n, '-');
    string t(n, '-');

    for (int i = 0; i < n; i++) {
        int r = rand() % 3;
        if (r == 0)
            continue;
        if (r == 1)
            s[i] = 'C';
        else
            s[i] = 'M';
    }
    t = s;
    random_shuffle(t.begin(), t.end());
    // for (int i = 0; i < n; i++) {
    //     int r = rand() % 3;
    //     if (r == 0)
    //         continue;
    //     if (r == 1)
    //         t[i] = 'C';
    //     else
    //         t[i] = 'M';
    // }
    return {s, t};
}

int32_t main() {
    int t = 1;

    t = 100000;
    while (t--)
    {
        auto [s, t] = test(7);
        if (s != t && stupid(s, t)) {
            cout << "TEST\n";
            cout << s << " " << t << "\n";
            solve(s, t);
        }
    }
    cout << "END\n";
    

    // cin >> t;
    while (t--) {
        int n;
        string s, t;
        cin >> n >> s >> t;
        solve(s, t);
    }
}