#include <bits/stdc++.h>
using namespace std;

#define p_b push_back 
#define fi first 
#define se second 

using pii = pair<int, int>;
using ll = long long;
const ll INF = 1e18;


bool intersect(pair<pii, int>a, pair<pii, int>b)
{
    auto [s, r1] = a;
    auto [x1, y1] = s;
    auto [s1, r2] = b;
    auto [x2, y2] = s1;
    return (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2) == (r1+r2)*(r1+r2);
}

void dfs(int u,vector<vector<int>> &g, vector<int>&clr, int &cnt1, int &cnt2)
{
    if(cnt1!=-1)
    {
    if(clr[u]==1)
    cnt1++;
    else
    cnt2++;
    }
    else
    clr[u]=-1;
    for(int i:g[u])
    {
        if(clr[i]==clr[u])
        {
            cnt1=-1;
            cnt2=-1;
        }
        else
        if(!clr[i])
        {
            clr[i] = 1+clr[u]%2;
            dfs(i, g, clr, cnt1, cnt2);
        }
    }
    if(cnt1==-1)
    clr[u]=-1;
}

void solve() {
    // freopen("1.in", "r", stdin);
    // freopen("1.out", "w", stdout);

    int n;
    cin>>n;
    vector<pair<pair<int, int>, int>>a(n);
    for(int i=0;i<n;i++)
    {
        cin>>a[i].fi.fi>>a[i].fi.se>>a[i].se;
    }
    vector<vector<int>>g(n);
    for(int i = 0;i<n;i++)
    {
        for(int j=0;j<i;j++)
        {
            if(intersect(a[i], a[j]))
            {
                g[i].p_b(j);
                g[j].p_b(i);
            }
        }
    }
    vector<int>clr(n);
    int x=0, y=0;
    for(int i=0;i<n;i++)
    {
        if(!clr[i])
        {
            clr[i] = 1;
            int cnt1=0, cnt2=0;
            dfs(i, g, clr, cnt1, cnt2);
            if(cnt1!=-1)
            {
                x+=min(cnt1, cnt2);
                y+=max(cnt1, cnt2);
            
            }

        }
    }
    if(x<y)
    {
        cout<<"YES";
    }
    else
    cout<<"NO";

}

int32_t main() {
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}